#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n,c,q,l,r,br=0;
    string s;
    cin>>n>>c>>q>>s;
    for(int i=0;i<n;i++)
        if(s[i]=='1')
            br++;
    for(int i=0;i<q;i++){
        cin>>l>>r;
        for(int j=l-1;j<r;j++){
            if(s[j]=='0'){
                s[j]='1';
                br++;
            }
            else{
                s[j]='0';
                br--;
            }
        }
        cout<<br<<"\n";
    }
    return 0;
}